(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.CardAction = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/CardAction.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        var result = Object.assign({}, attributes);
        var cls ="mdc-card__actions";
        var classes = [cls];
        if (result.full) {
            classes.push(cls+"--full-bleed");
        }
        delete result.full;
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function create_main_fragment(component, ctx) {
    	var div, slot_content_default = component._slotted.default;

    	var div_levels = [
    		ctx.attrs
    	];

    	var div_data = {};
    	for (var i = 0; i < div_levels.length; i += 1) {
    		div_data = shared_js.assign(div_data, div_levels[i]);
    	}

    	return {
    		c() {
    			div = shared_js.createElement("div");
    			shared_js.setAttributes(div, div_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, div, anchor);

    			if (slot_content_default) {
    				shared_js.append(div, slot_content_default);
    			}
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(div, shared_js.getSpreadUpdate(div_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(div);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(div, slot_content_default);
    			}
    		}
    	};
    }

    function CardAction(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(CardAction.prototype, shared_js.proto);

    CardAction.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return CardAction;

})));
