(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.DrawerHeader = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/DrawerHeader.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({}, attributes);
        let classes = ["mdc-drawer__header"];
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function create_main_fragment(component, ctx) {
    	var header, div, slot_content_default = component._slotted.default;

    	var header_levels = [
    		ctx.attrs
    	];

    	var header_data = {};
    	for (var i = 0; i < header_levels.length; i += 1) {
    		header_data = shared_js.assign(header_data, header_levels[i]);
    	}

    	return {
    		c() {
    			header = shared_js.createElement("header");
    			div = shared_js.createElement("div");
    			div.className = "mdc-drawer__header-content";
    			shared_js.setAttributes(header, header_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, header, anchor);
    			shared_js.append(header, div);

    			if (slot_content_default) {
    				shared_js.append(div, slot_content_default);
    			}
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(header, shared_js.getSpreadUpdate(header_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(header);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(div, slot_content_default);
    			}
    		}
    	};
    }

    function DrawerHeader(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(DrawerHeader.prototype, shared_js.proto);

    DrawerHeader.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return DrawerHeader;

})));
