(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.Elevation = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    /* src/Elevation.html generated by Svelte v2.9.11 */

    function data() {
        return {
            transitions: false
        }
    }
    function onstate({current, changed, previous}) {
        if (typeof current.z !== "number" || Math.floor(current.z) !== current.z || current.z < 1 || current.z > 24 ) {
            throw new Error("Z must be a integer between 1 and 25");
        }
    }
    function create_main_fragment(component, ctx) {
    	var div, slot_content_default = component._slotted.default, div_class_value;

    	return {
    		c() {
    			div = shared_js.createElement("div");
    			div.className = div_class_value = "mdc-elevation--z" + ctx.z + " " + (ctx.transitions?'mdc-elevation-transition':'');
    		},

    		m(target, anchor) {
    			shared_js.insert(target, div, anchor);

    			if (slot_content_default) {
    				shared_js.append(div, slot_content_default);
    			}
    		},

    		p(changed, ctx) {
    			if ((changed.z || changed.transitions) && div_class_value !== (div_class_value = "mdc-elevation--z" + ctx.z + " " + (ctx.transitions?'mdc-elevation-transition':''))) {
    				div.className = div_class_value;
    			}
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(div);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(div, slot_content_default);
    			}
    		}
    	};
    }

    function Elevation(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign(data(), options.data);
    	this._intro = true;

    	this._handlers.state = [onstate];

    	this._slotted = options.slots || {};

    	if (!options.root) {
    		this._oncreate = [];
    	}

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	this.root._oncreate.push(() => {
    		onstate.call(this, { changed: shared_js.assignTrue({}, this._state), current: this._state });
    		this.fire("update", { changed: shared_js.assignTrue({}, this._state), current: this._state });
    	});

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);

    		shared_js.callAll(this._oncreate);
    	}
    }

    shared_js.assign(Elevation.prototype, shared_js.proto);

    return Elevation;

})));
