import { append, assign, assignTrue, callAll, createElement, detachNode, init, insert, proto, reinsertChildren } from './shared.mjs';

/* src/Elevation.html generated by Svelte v2.9.11 */

function data() {
    return {
        transitions: false
    }
}
function onstate({current, changed, previous}) {
    if (typeof current.z !== "number" || Math.floor(current.z) !== current.z || current.z < 1 || current.z > 24 ) {
        throw new Error("Z must be a integer between 1 and 25");
    }
}
function create_main_fragment(component, ctx) {
	var div, slot_content_default = component._slotted.default, div_class_value;

	return {
		c() {
			div = createElement("div");
			div.className = div_class_value = "mdc-elevation--z" + ctx.z + " " + (ctx.transitions?'mdc-elevation-transition':'');
		},

		m(target, anchor) {
			insert(target, div, anchor);

			if (slot_content_default) {
				append(div, slot_content_default);
			}
		},

		p(changed, ctx) {
			if ((changed.z || changed.transitions) && div_class_value !== (div_class_value = "mdc-elevation--z" + ctx.z + " " + (ctx.transitions?'mdc-elevation-transition':''))) {
				div.className = div_class_value;
			}
		},

		d(detach) {
			if (detach) {
				detachNode(div);
			}

			if (slot_content_default) {
				reinsertChildren(div, slot_content_default);
			}
		}
	};
}

function Elevation(options) {
	init(this, options);
	this._state = assign(data(), options.data);
	this._intro = true;

	this._handlers.state = [onstate];

	this._slotted = options.slots || {};

	if (!options.root) {
		this._oncreate = [];
	}

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	this.root._oncreate.push(() => {
		onstate.call(this, { changed: assignTrue({}, this._state), current: this._state });
		this.fire("update", { changed: assignTrue({}, this._state), current: this._state });
	});

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);

		callAll(this._oncreate);
	}
}

assign(Elevation.prototype, proto);

export default Elevation;
