(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.GridListTile = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/Icon.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({"aria_hidden": "true"}, attributes);
        let classes = ["material-icons"];
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    var methods = {
    	getElement() {
    		return this.refs.icon;
    	}
    };

    function create_main_fragment(component, ctx) {
    	var i, slot_content_default = component._slotted.default;

    	function click_handler(event) {
    		component.fire("click", event);
    	}

    	var i_levels = [
    		ctx.attrs
    	];

    	var i_data = {};
    	for (var i_1 = 0; i_1 < i_levels.length; i_1 += 1) {
    		i_data = shared_js.assign(i_data, i_levels[i_1]);
    	}

    	return {
    		c() {
    			i = shared_js.createElement("i");
    			shared_js.addListener(i, "click", click_handler);
    			shared_js.setAttributes(i, i_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, i, anchor);

    			if (slot_content_default) {
    				shared_js.append(i, slot_content_default);
    			}

    			component.refs.icon = i;
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(i, shared_js.getSpreadUpdate(i_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(i);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(i, slot_content_default);
    			}

    			shared_js.removeListener(i, "click", click_handler);
    			if (component.refs.icon === i) component.refs.icon = null;
    		}
    	};
    }

    function Icon(options) {
    	shared_js.init(this, options);
    	this.refs = {};
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(Icon.prototype, shared_js.proto);
    shared_js.assign(Icon.prototype, methods);

    Icon.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    /* src/GridListTile.html generated by Svelte v2.9.11 */

    function create_main_fragment$1(component, ctx) {
    	var li, div, text_1;

    	function select_block_type(ctx) {
    		if (ctx.bgImage) return create_if_block;
    		return create_if_block_1;
    	}

    	var current_block_type = select_block_type(ctx);
    	var if_block = current_block_type(component, ctx);

    	var if_block_1 = (ctx.title) && create_if_block_2(component, ctx);

    	return {
    		c() {
    			li = shared_js.createElement("li");
    			div = shared_js.createElement("div");
    			if_block.c();
    			text_1 = shared_js.createText("\n  ");
    			if (if_block_1) if_block_1.c();
    			div.className = "mdc-grid-tile__primary";
    			li.className = "mdc-grid-tile";
    		},

    		m(target, anchor) {
    			shared_js.insert(target, li, anchor);
    			shared_js.append(li, div);
    			if_block.m(div, null);
    			shared_js.append(li, text_1);
    			if (if_block_1) if_block_1.m(li, null);
    		},

    		p(changed, ctx) {
    			if (current_block_type === (current_block_type = select_block_type(ctx)) && if_block) {
    				if_block.p(changed, ctx);
    			} else {
    				if_block.d(1);
    				if_block = current_block_type(component, ctx);
    				if_block.c();
    				if_block.m(div, null);
    			}

    			if (ctx.title) {
    				if (if_block_1) {
    					if_block_1.p(changed, ctx);
    				} else {
    					if_block_1 = create_if_block_2(component, ctx);
    					if_block_1.c();
    					if_block_1.m(li, null);
    				}
    			} else if (if_block_1) {
    				if_block_1.d(1);
    				if_block_1 = null;
    			}
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(li);
    			}

    			if_block.d();
    			if (if_block_1) if_block_1.d();
    		}
    	};
    }

    // (3:4) {#if bgImage}
    function create_if_block(component, ctx) {
    	var div;

    	return {
    		c() {
    			div = shared_js.createElement("div");
    			div.className = "mdc-grid-tile__primary-content";
    			shared_js.setStyle(div, "background-image", "url(" + ctx.src + ")");
    		},

    		m(target, anchor) {
    			shared_js.insert(target, div, anchor);
    		},

    		p(changed, ctx) {
    			if (changed.src) {
    				shared_js.setStyle(div, "background-image", "url(" + ctx.src + ")");
    			}
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(div);
    			}
    		}
    	};
    }

    // (5:4) {:else}
    function create_if_block_1(component, ctx) {
    	var img;

    	return {
    		c() {
    			img = shared_js.createElement("img");
    			img.className = "mdc-grid-tile__primary-content";
    			img.src = ctx.src;
    			img.alt = ctx.title;
    		},

    		m(target, anchor) {
    			shared_js.insert(target, img, anchor);
    		},

    		p(changed, ctx) {
    			if (changed.src) {
    				img.src = ctx.src;
    			}

    			if (changed.title) {
    				img.alt = ctx.title;
    			}
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(img);
    			}
    		}
    	};
    }

    // (11:4) {#if icon}
    function create_if_block_3(component, ctx) {
    	var text;

    	var icon_initial_data = {
    	 	class: "mdc-grid-tile__icon material-icons"
    	 };
    	var icon = new Icon({
    		root: component.root,
    		store: component.store,
    		slots: { default: shared_js.createFragment() },
    		data: icon_initial_data
    	});

    	return {
    		c() {
    			text = shared_js.createText(ctx.icon);
    			icon._fragment.c();
    		},

    		m(target, anchor) {
    			shared_js.append(icon._slotted.default, text);
    			icon._mount(target, anchor);
    		},

    		p(changed, ctx) {
    			if (changed.icon) {
    				shared_js.setData(text, ctx.icon);
    			}
    		},

    		d(detach) {
    			icon.destroy(detach);
    		}
    	};
    }

    // (15:4) {#if supportText}
    function create_if_block_4(component, ctx) {
    	var span, text;

    	return {
    		c() {
    			span = shared_js.createElement("span");
    			text = shared_js.createText(ctx.supportText);
    			span.className = "mdc-grid-tile__support-text";
    		},

    		m(target, anchor) {
    			shared_js.insert(target, span, anchor);
    			shared_js.append(span, text);
    		},

    		p(changed, ctx) {
    			if (changed.supportText) {
    				shared_js.setData(text, ctx.supportText);
    			}
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(span);
    			}
    		}
    	};
    }

    // (9:2) {#if title}
    function create_if_block_2(component, ctx) {
    	var span, text, span_1, text_1, text_2;

    	var if_block = (ctx.icon) && create_if_block_3(component, ctx);

    	var if_block_1 = (ctx.supportText) && create_if_block_4(component, ctx);

    	return {
    		c() {
    			span = shared_js.createElement("span");
    			if (if_block) if_block.c();
    			text = shared_js.createText("\n    ");
    			span_1 = shared_js.createElement("span");
    			text_1 = shared_js.createText(ctx.title);
    			text_2 = shared_js.createText("\n    ");
    			if (if_block_1) if_block_1.c();
    			span_1.className = "mdc-grid-tile__title";
    			span.className = "mdc-grid-tile__secondary";
    		},

    		m(target, anchor) {
    			shared_js.insert(target, span, anchor);
    			if (if_block) if_block.m(span, null);
    			shared_js.append(span, text);
    			shared_js.append(span, span_1);
    			shared_js.append(span_1, text_1);
    			shared_js.append(span, text_2);
    			if (if_block_1) if_block_1.m(span, null);
    		},

    		p(changed, ctx) {
    			if (ctx.icon) {
    				if (if_block) {
    					if_block.p(changed, ctx);
    				} else {
    					if_block = create_if_block_3(component, ctx);
    					if_block.c();
    					if_block.m(span, text);
    				}
    			} else if (if_block) {
    				if_block.d(1);
    				if_block = null;
    			}

    			if (changed.title) {
    				shared_js.setData(text_1, ctx.title);
    			}

    			if (ctx.supportText) {
    				if (if_block_1) {
    					if_block_1.p(changed, ctx);
    				} else {
    					if_block_1 = create_if_block_4(component, ctx);
    					if_block_1.c();
    					if_block_1.m(span, null);
    				}
    			} else if (if_block_1) {
    				if_block_1.d(1);
    				if_block_1 = null;
    			}
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(span);
    			}

    			if (if_block) if_block.d();
    			if (if_block_1) if_block_1.d();
    		}
    	};
    }

    function GridListTile(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._intro = true;

    	if (!options.root) {
    		this._oncreate = [];
    		this._beforecreate = [];
    		this._aftercreate = [];
    	}

    	this._fragment = create_main_fragment$1(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);

    		this._lock = true;
    		shared_js.callAll(this._beforecreate);
    		shared_js.callAll(this._oncreate);
    		shared_js.callAll(this._aftercreate);
    		this._lock = false;
    	}
    }

    shared_js.assign(GridListTile.prototype, shared_js.proto);

    return GridListTile;

})));
