import { addListener, append, assign, createElement, detachNode, getSpreadUpdate, init, insert, proto, reinsertChildren, removeListener, setAttributes } from './shared.mjs';

const regex = /%s/gi;

function processClasses(classes, userClasses) {
    if (!userClasses) {
        return classes.join(" ");
    }
    if (Array.isArray(userClasses)) {
        userClasses = userClasses.join(" ");
    }
    if (!regex.test(userClasses)) {
        return userClasses+" "+classes.join(" ");
    }
    return userClasses.replace(regex, classes.join(" "));
}

/* src/Icon.html generated by Svelte v2.9.11 */

function attrs(attributes) {
    let result = Object.assign({"aria_hidden": "true"}, attributes);
    let classes = ["material-icons"];
    delete result.attrs;
    result["class"] = processClasses(classes, result["class"]);
    return result;
}
var methods = {
	getElement() {
		return this.refs.icon;
	}
};

function create_main_fragment(component, ctx) {
	var i, slot_content_default = component._slotted.default;

	function click_handler(event) {
		component.fire("click", event);
	}

	var i_levels = [
		ctx.attrs
	];

	var i_data = {};
	for (var i_1 = 0; i_1 < i_levels.length; i_1 += 1) {
		i_data = assign(i_data, i_levels[i_1]);
	}

	return {
		c() {
			i = createElement("i");
			addListener(i, "click", click_handler);
			setAttributes(i, i_data);
		},

		m(target, anchor) {
			insert(target, i, anchor);

			if (slot_content_default) {
				append(i, slot_content_default);
			}

			component.refs.icon = i;
		},

		p(changed, ctx) {
			setAttributes(i, getSpreadUpdate(i_levels, [
				(changed.attrs) && ctx.attrs
			]));
		},

		d(detach) {
			if (detach) {
				detachNode(i);
			}

			if (slot_content_default) {
				reinsertChildren(i, slot_content_default);
			}

			removeListener(i, "click", click_handler);
			if (component.refs.icon === i) component.refs.icon = null;
		}
	};
}

function Icon(options) {
	init(this, options);
	this.refs = {};
	this._state = assign({}, options.data);
	this._recompute({  }, this._state);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(Icon.prototype, proto);
assign(Icon.prototype, methods);

Icon.prototype._recompute = function _recompute(changed, state) {
	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
};

export default Icon;
