import { append, assign, createElement, detachNode, getSpreadUpdate, init, insert, proto, reinsertChildren, setAttributes } from './shared.mjs';

const regex = /%s/gi;

function processClasses(classes, userClasses) {
    if (!userClasses) {
        return classes.join(" ");
    }
    if (Array.isArray(userClasses)) {
        userClasses = userClasses.join(" ");
    }
    if (!regex.test(userClasses)) {
        return userClasses+" "+classes.join(" ");
    }
    return userClasses.replace(regex, classes.join(" "));
}

/* src/ImageList.html generated by Svelte v2.9.11 */

function attrs(attributes) {
    let result = Object.assign({}, attributes);
    let cls = "mdc-image-list";
    let classes = [cls];
    for (let key of ["masonry", "with-text-protection"]) {
        if (result[key]) {
            classes.push(cls+"--"+key);
        }
        delete result[key];
    }
    delete result.attrs;
    result["class"] = processClasses(classes, result["class"]);
    return result;
}
function create_main_fragment(component, ctx) {
	var ul, slot_content_default = component._slotted.default;

	var ul_levels = [
		ctx.attrs
	];

	var ul_data = {};
	for (var i = 0; i < ul_levels.length; i += 1) {
		ul_data = assign(ul_data, ul_levels[i]);
	}

	return {
		c() {
			ul = createElement("ul");
			setAttributes(ul, ul_data);
		},

		m(target, anchor) {
			insert(target, ul, anchor);

			if (slot_content_default) {
				append(ul, slot_content_default);
			}
		},

		p(changed, ctx) {
			setAttributes(ul, getSpreadUpdate(ul_levels, [
				(changed.attrs) && ctx.attrs
			]));
		},

		d(detach) {
			if (detach) {
				detachNode(ul);
			}

			if (slot_content_default) {
				reinsertChildren(ul, slot_content_default);
			}
		}
	};
}

function ImageList(options) {
	init(this, options);
	this._state = assign({}, options.data);
	this._recompute({  }, this._state);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(ImageList.prototype, proto);

ImageList.prototype._recompute = function _recompute(changed, state) {
	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
};

export default ImageList;
