(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
  typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
  (global.ImageListItem = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

  /* src/ImageListItem.html generated by Svelte v2.9.11 */

  function onstate({current}) {
      if (!current.src) {
          throw new Error("Attribute 'src' should be defined");
      }
  }
  function create_main_fragment(component, ctx) {
  	var li, text;

  	function select_block_type(ctx) {
  		if (ctx.aspectContainer) return create_if_block;
  		return create_if_block_1;
  	}

  	var current_block_type = select_block_type(ctx);
  	var if_block = current_block_type(component, ctx);

  	var if_block_1 = (ctx.textLabel) && create_if_block_2(component, ctx);

  	return {
  		c() {
  			li = shared_js.createElement("li");
  			if_block.c();
  			text = shared_js.createText("\n  ");
  			if (if_block_1) if_block_1.c();
  			li.className = "mdc-image-list__item";
  		},

  		m(target, anchor) {
  			shared_js.insert(target, li, anchor);
  			if_block.m(li, null);
  			shared_js.append(li, text);
  			if (if_block_1) if_block_1.m(li, null);
  		},

  		p(changed, ctx) {
  			if (current_block_type === (current_block_type = select_block_type(ctx)) && if_block) {
  				if_block.p(changed, ctx);
  			} else {
  				if_block.d(1);
  				if_block = current_block_type(component, ctx);
  				if_block.c();
  				if_block.m(li, text);
  			}

  			if (ctx.textLabel) {
  				if (if_block_1) {
  					if_block_1.p(changed, ctx);
  				} else {
  					if_block_1 = create_if_block_2(component, ctx);
  					if_block_1.c();
  					if_block_1.m(li, null);
  				}
  			} else if (if_block_1) {
  				if_block_1.d(1);
  				if_block_1 = null;
  			}
  		},

  		d(detach) {
  			if (detach) {
  				shared_js.detachNode(li);
  			}

  			if_block.d();
  			if (if_block_1) if_block_1.d();
  		}
  	};
  }

  // (2:2) {#if aspectContainer}
  function create_if_block(component, ctx) {
  	var div, img;

  	return {
  		c() {
  			div = shared_js.createElement("div");
  			img = shared_js.createElement("img");
  			img.className = "mdc-image-list__image";
  			img.src = ctx.src;
  			div.className = "mdc-image-list__image-aspect-container";
  		},

  		m(target, anchor) {
  			shared_js.insert(target, div, anchor);
  			shared_js.append(div, img);
  		},

  		p(changed, ctx) {
  			if (changed.src) {
  				img.src = ctx.src;
  			}
  		},

  		d(detach) {
  			if (detach) {
  				shared_js.detachNode(div);
  			}
  		}
  	};
  }

  // (6:2) {:else}
  function create_if_block_1(component, ctx) {
  	var img;

  	return {
  		c() {
  			img = shared_js.createElement("img");
  			img.className = "mdc-image-list__image";
  			img.src = ctx.src;
  		},

  		m(target, anchor) {
  			shared_js.insert(target, img, anchor);
  		},

  		p(changed, ctx) {
  			if (changed.src) {
  				img.src = ctx.src;
  			}
  		},

  		d(detach) {
  			if (detach) {
  				shared_js.detachNode(img);
  			}
  		}
  	};
  }

  // (9:2) {#if textLabel}
  function create_if_block_2(component, ctx) {
  	var div, span, text;

  	return {
  		c() {
  			div = shared_js.createElement("div");
  			span = shared_js.createElement("span");
  			text = shared_js.createText(ctx.textLabel);
  			span.className = "mdc-image-list__label";
  			div.className = "mdc-image-list__supporting";
  		},

  		m(target, anchor) {
  			shared_js.insert(target, div, anchor);
  			shared_js.append(div, span);
  			shared_js.append(span, text);
  		},

  		p(changed, ctx) {
  			if (changed.textLabel) {
  				shared_js.setData(text, ctx.textLabel);
  			}
  		},

  		d(detach) {
  			if (detach) {
  				shared_js.detachNode(div);
  			}
  		}
  	};
  }

  function ImageListItem(options) {
  	shared_js.init(this, options);
  	this._state = shared_js.assign({}, options.data);
  	this._intro = true;

  	this._handlers.state = [onstate];

  	if (!options.root) {
  		this._oncreate = [];
  	}

  	this._fragment = create_main_fragment(this, this._state);

  	this.root._oncreate.push(() => {
  		onstate.call(this, { changed: shared_js.assignTrue({}, this._state), current: this._state });
  		this.fire("update", { changed: shared_js.assignTrue({}, this._state), current: this._state });
  	});

  	if (options.target) {
  		this._fragment.c();
  		this._mount(options.target, options.anchor);

  		shared_js.callAll(this._oncreate);
  	}
  }

  shared_js.assign(ImageListItem.prototype, shared_js.proto);

  return ImageListItem;

})));
