(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.LayoutGrid = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/LayoutGridInner.html generated by Svelte v2.9.11 */

    function create_main_fragment(component, ctx) {
    	var div, slot_content_default = component._slotted.default;

    	return {
    		c() {
    			div = shared_js.createElement("div");
    			div.className = "mdc-layout-grid__inner";
    		},

    		m(target, anchor) {
    			shared_js.insert(target, div, anchor);

    			if (slot_content_default) {
    				shared_js.append(div, slot_content_default);
    			}
    		},

    		p: shared_js.noop,

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(div);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(div, slot_content_default);
    			}
    		}
    	};
    }

    function LayoutGridInner(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(LayoutGridInner.prototype, shared_js.proto);

    /* src/LayoutGrid.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({}, attributes);
        let cls ="mdc-layout-grid";
        let classes = [cls];
        if (result.align) {
            classes.push(cls+"--align-"+result.align);
        }
        delete result.align;
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function onstate({current}) {
        if (current.align && ['top', 'middle', 'bottom'].includes(current.align)) {
            throw new Error(`Invalid value for "align" attribute: "${current.align}", should be "top", "middle" or "bottom"`);
        }
    }
    function create_main_fragment$1(component, ctx) {
    	var div, slot_content_default = component._slotted.default;

    	var layoutgridinner = new LayoutGridInner({
    		root: component.root,
    		store: component.store,
    		slots: { default: shared_js.createFragment() }
    	});

    	return {
    		c() {
    			div = shared_js.createElement("div");
    			layoutgridinner._fragment.c();
    			div.className = "mdc-layout-grid";
    		},

    		m(target, anchor) {
    			shared_js.insert(target, div, anchor);

    			if (slot_content_default) {
    				shared_js.append(layoutgridinner._slotted.default, slot_content_default);
    			}

    			layoutgridinner._mount(div, null);
    		},

    		p: shared_js.noop,

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(div);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(layoutgridinner._slotted.default, slot_content_default);
    			}

    			layoutgridinner.destroy();
    		}
    	};
    }

    function LayoutGrid(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._handlers.state = [onstate];

    	this._slotted = options.slots || {};

    	if (!options.root) {
    		this._oncreate = [];
    		this._beforecreate = [];
    		this._aftercreate = [];
    	}

    	this.slots = {};

    	this._fragment = create_main_fragment$1(this, this._state);

    	this.root._oncreate.push(() => {
    		onstate.call(this, { changed: shared_js.assignTrue({}, this._state), current: this._state });
    		this.fire("update", { changed: shared_js.assignTrue({}, this._state), current: this._state });
    	});

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);

    		this._lock = true;
    		shared_js.callAll(this._beforecreate);
    		shared_js.callAll(this._oncreate);
    		shared_js.callAll(this._aftercreate);
    		this._lock = false;
    	}
    }

    shared_js.assign(LayoutGrid.prototype, shared_js.proto);

    LayoutGrid.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return LayoutGrid;

})));
