import { append, assign, createElement, detachNode, init, insert, noop, proto, reinsertChildren, assignTrue, callAll, createFragment } from './shared.mjs';

const regex = /%s/gi;

function processClasses(classes, userClasses) {
    if (!userClasses) {
        return classes.join(" ");
    }
    if (Array.isArray(userClasses)) {
        userClasses = userClasses.join(" ");
    }
    if (!regex.test(userClasses)) {
        return userClasses+" "+classes.join(" ");
    }
    return userClasses.replace(regex, classes.join(" "));
}

/* src/LayoutGridInner.html generated by Svelte v2.9.11 */

function create_main_fragment(component, ctx) {
	var div, slot_content_default = component._slotted.default;

	return {
		c() {
			div = createElement("div");
			div.className = "mdc-layout-grid__inner";
		},

		m(target, anchor) {
			insert(target, div, anchor);

			if (slot_content_default) {
				append(div, slot_content_default);
			}
		},

		p: noop,

		d(detach) {
			if (detach) {
				detachNode(div);
			}

			if (slot_content_default) {
				reinsertChildren(div, slot_content_default);
			}
		}
	};
}

function LayoutGridInner(options) {
	init(this, options);
	this._state = assign({}, options.data);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(LayoutGridInner.prototype, proto);

/* src/LayoutGrid.html generated by Svelte v2.9.11 */

function attrs(attributes) {
    let result = Object.assign({}, attributes);
    let cls ="mdc-layout-grid";
    let classes = [cls];
    if (result.align) {
        classes.push(cls+"--align-"+result.align);
    }
    delete result.align;
    delete result.attrs;
    result["class"] = processClasses(classes, result["class"]);
    return result;
}
function onstate({current}) {
    if (current.align && ['top', 'middle', 'bottom'].includes(current.align)) {
        throw new Error(`Invalid value for "align" attribute: "${current.align}", should be "top", "middle" or "bottom"`);
    }
}
function create_main_fragment$1(component, ctx) {
	var div, slot_content_default = component._slotted.default;

	var layoutgridinner = new LayoutGridInner({
		root: component.root,
		store: component.store,
		slots: { default: createFragment() }
	});

	return {
		c() {
			div = createElement("div");
			layoutgridinner._fragment.c();
			div.className = "mdc-layout-grid";
		},

		m(target, anchor) {
			insert(target, div, anchor);

			if (slot_content_default) {
				append(layoutgridinner._slotted.default, slot_content_default);
			}

			layoutgridinner._mount(div, null);
		},

		p: noop,

		d(detach) {
			if (detach) {
				detachNode(div);
			}

			if (slot_content_default) {
				reinsertChildren(layoutgridinner._slotted.default, slot_content_default);
			}

			layoutgridinner.destroy();
		}
	};
}

function LayoutGrid(options) {
	init(this, options);
	this._state = assign({}, options.data);
	this._recompute({  }, this._state);
	this._intro = true;

	this._handlers.state = [onstate];

	this._slotted = options.slots || {};

	if (!options.root) {
		this._oncreate = [];
		this._beforecreate = [];
		this._aftercreate = [];
	}

	this.slots = {};

	this._fragment = create_main_fragment$1(this, this._state);

	this.root._oncreate.push(() => {
		onstate.call(this, { changed: assignTrue({}, this._state), current: this._state });
		this.fire("update", { changed: assignTrue({}, this._state), current: this._state });
	});

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);

		this._lock = true;
		callAll(this._beforecreate);
		callAll(this._oncreate);
		callAll(this._aftercreate);
		this._lock = false;
	}
}

assign(LayoutGrid.prototype, proto);

LayoutGrid.prototype._recompute = function _recompute(changed, state) {
	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
};

export default LayoutGrid;
