(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.List = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/List.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({}, attributes);
        let cls ="mdc-list";
        let classes = [cls];
        for (let key of ["two-line", "dense", "non-interactive", "avatar-list"]) {
            if (result[key]) {
                classes.push(cls+"--"+key);
            }
            delete result[key];
        }
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function create_main_fragment(component, ctx) {
    	var ul, slot_content_default = component._slotted.default;

    	var ul_levels = [
    		ctx.attrs
    	];

    	var ul_data = {};
    	for (var i = 0; i < ul_levels.length; i += 1) {
    		ul_data = shared_js.assign(ul_data, ul_levels[i]);
    	}

    	return {
    		c() {
    			ul = shared_js.createElement("ul");
    			shared_js.setAttributes(ul, ul_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, ul, anchor);

    			if (slot_content_default) {
    				shared_js.append(ul, slot_content_default);
    			}
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(ul, shared_js.getSpreadUpdate(ul_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(ul);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(ul, slot_content_default);
    			}
    		}
    	};
    }

    function List(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(List.prototype, shared_js.proto);

    List.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return List;

})));
