(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.ListDivider = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/ListDivider.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({}, attributes);
        let classes = ["mdc-list-divider"];
        if (result["inList"]) {
            result.role = "separator";
        }
        delete result.inList;
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function data() {
        return {
            inList: false
        }
    }
    function create_main_fragment(component, ctx) {
    	var if_block_anchor;

    	function select_block_type(ctx) {
    		if (ctx.inList) return create_if_block;
    		return create_if_block_1;
    	}

    	var current_block_type = select_block_type(ctx);
    	var if_block = current_block_type(component, ctx);

    	return {
    		c() {
    			if_block.c();
    			if_block_anchor = shared_js.createComment();
    		},

    		m(target, anchor) {
    			if_block.m(target, anchor);
    			shared_js.insert(target, if_block_anchor, anchor);
    		},

    		p(changed, ctx) {
    			if (current_block_type === (current_block_type = select_block_type(ctx)) && if_block) {
    				if_block.p(changed, ctx);
    			} else {
    				if_block.d(1);
    				if_block = current_block_type(component, ctx);
    				if_block.c();
    				if_block.m(if_block_anchor.parentNode, if_block_anchor);
    			}
    		},

    		d(detach) {
    			if_block.d(detach);
    			if (detach) {
    				shared_js.detachNode(if_block_anchor);
    			}
    		}
    	};
    }

    // (1:0) {#if inList}
    function create_if_block(component, ctx) {
    	var li;

    	var li_levels = [
    		ctx.attrs
    	];

    	var li_data = {};
    	for (var i = 0; i < li_levels.length; i += 1) {
    		li_data = shared_js.assign(li_data, li_levels[i]);
    	}

    	return {
    		c() {
    			li = shared_js.createElement("li");
    			shared_js.setAttributes(li, li_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, li, anchor);
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(li, shared_js.getSpreadUpdate(li_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(li);
    			}
    		}
    	};
    }

    // (3:0) {:else}
    function create_if_block_1(component, ctx) {
    	var hr;

    	var hr_levels = [
    		ctx.attrs
    	];

    	var hr_data = {};
    	for (var i = 0; i < hr_levels.length; i += 1) {
    		hr_data = shared_js.assign(hr_data, hr_levels[i]);
    	}

    	return {
    		c() {
    			hr = shared_js.createElement("hr");
    			shared_js.setAttributes(hr, hr_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, hr, anchor);
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(hr, shared_js.getSpreadUpdate(hr_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(hr);
    			}
    		}
    	};
    }

    function ListDivider(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign(data(), options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(ListDivider.prototype, shared_js.proto);

    ListDivider.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return ListDivider;

})));
