(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.ListGroupSubheader = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/ListGroupSubheader.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({}, attributes);
        let cls ="mdc-list-group__subheader";
        let classes = [cls];
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function create_main_fragment(component, ctx) {
    	var h3, slot_content_default = component._slotted.default;

    	var h3_levels = [
    		ctx.attrs
    	];

    	var h3_data = {};
    	for (var i = 0; i < h3_levels.length; i += 1) {
    		h3_data = shared_js.assign(h3_data, h3_levels[i]);
    	}

    	return {
    		c() {
    			h3 = shared_js.createElement("h3");
    			shared_js.setAttributes(h3, h3_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, h3, anchor);

    			if (slot_content_default) {
    				shared_js.append(h3, slot_content_default);
    			}
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(h3, shared_js.getSpreadUpdate(h3_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(h3);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(h3, slot_content_default);
    			}
    		}
    	};
    }

    function ListGroupSubheader(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(ListGroupSubheader.prototype, shared_js.proto);

    ListGroupSubheader.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return ListGroupSubheader;

})));
