import { append, assign, createElement, detachNode, getSpreadUpdate, init, insert, proto, reinsertChildren, setAttributes } from './shared.mjs';

const regex = /%s/gi;

function processClasses(classes, userClasses) {
    if (!userClasses) {
        return classes.join(" ");
    }
    if (Array.isArray(userClasses)) {
        userClasses = userClasses.join(" ");
    }
    if (!regex.test(userClasses)) {
        return userClasses+" "+classes.join(" ");
    }
    return userClasses.replace(regex, classes.join(" "));
}

/* src/PermanentDrawer.html generated by Svelte v2.9.11 */

function attrs(attributes) {
    let result = Object.assign({}, attributes);
    let classes = ["mdc-drawer", "mdc-drawer--permanent"];
    delete result.attrs;
    result["class"] = processClasses(classes, result["class"]);
    return result;
}
function create_main_fragment(component, ctx) {
	var nav, slot_content_default = component._slotted.default;

	var nav_levels = [
		ctx.attrs
	];

	var nav_data = {};
	for (var i = 0; i < nav_levels.length; i += 1) {
		nav_data = assign(nav_data, nav_levels[i]);
	}

	return {
		c() {
			nav = createElement("nav");
			setAttributes(nav, nav_data);
		},

		m(target, anchor) {
			insert(target, nav, anchor);

			if (slot_content_default) {
				append(nav, slot_content_default);
			}

			component.refs.drawer = nav;
		},

		p(changed, ctx) {
			setAttributes(nav, getSpreadUpdate(nav_levels, [
				(changed.attrs) && ctx.attrs
			]));
		},

		d(detach) {
			if (detach) {
				detachNode(nav);
			}

			if (slot_content_default) {
				reinsertChildren(nav, slot_content_default);
			}

			if (component.refs.drawer === nav) component.refs.drawer = null;
		}
	};
}

function PermanentDrawer(options) {
	init(this, options);
	this.refs = {};
	this._state = assign({}, options.data);
	this._recompute({  }, this._state);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(PermanentDrawer.prototype, proto);

PermanentDrawer.prototype._recompute = function _recompute(changed, state) {
	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
};

export default PermanentDrawer;
