import { append, assign, createElement, createText, detachNode, init, insert, proto, setAttribute } from './shared.mjs';

/* src/Switch.html generated by Svelte v2.9.11 */

function create_main_fragment(component, ctx) {
	var div, input, text, div_1;

	return {
		c() {
			div = createElement("div");
			input = createElement("input");
			text = createText("\n  ");
			div_1 = createElement("div");
			div_1.innerHTML = "<div class=\"mdc-switch__knob\"></div>";
			setAttribute(input, "type", "checkbox");
			input.id = ctx.id;
			input.className = "mdc-switch__native-control";
			setAttribute(input, "role", "switch");
			input.disabled = ctx.disabled;
			div_1.className = "mdc-switch__background";
			div.className = "mdc-switch";
		},

		m(target, anchor) {
			insert(target, div, anchor);
			append(div, input);
			append(div, text);
			append(div, div_1);
			component.refs.switch = div;
		},

		p(changed, ctx) {
			if (changed.id) {
				input.id = ctx.id;
			}

			if (changed.disabled) {
				input.disabled = ctx.disabled;
			}
		},

		d(detach) {
			if (detach) {
				detachNode(div);
			}

			if (component.refs.switch === div) component.refs.switch = null;
		}
	};
}

function Switch(options) {
	init(this, options);
	this.refs = {};
	this._state = assign({}, options.data);
	this._intro = true;

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(Switch.prototype, proto);

export default Switch;
