import { addListener, append, assign, createElement, detachNode, getSpreadUpdate, init, insert, proto, reinsertChildren, removeListener, setAttributes, callAll, createComment, createFragment, createText, reinsertBetween, setData } from './shared.mjs';

const regex = /%s/gi;

function processClasses(classes, userClasses) {
    if (!userClasses) {
        return classes.join(" ");
    }
    if (Array.isArray(userClasses)) {
        userClasses = userClasses.join(" ");
    }
    if (!regex.test(userClasses)) {
        return userClasses+" "+classes.join(" ");
    }
    return userClasses.replace(regex, classes.join(" "));
}

/* src/Icon.html generated by Svelte v2.9.11 */

function attrs(attributes) {
    let result = Object.assign({"aria_hidden": "true"}, attributes);
    let classes = ["material-icons"];
    delete result.attrs;
    result["class"] = processClasses(classes, result["class"]);
    return result;
}
var methods = {
	getElement() {
		return this.refs.icon;
	}
};

function create_main_fragment(component, ctx) {
	var i, slot_content_default = component._slotted.default;

	function click_handler(event) {
		component.fire("click", event);
	}

	var i_levels = [
		ctx.attrs
	];

	var i_data = {};
	for (var i_1 = 0; i_1 < i_levels.length; i_1 += 1) {
		i_data = assign(i_data, i_levels[i_1]);
	}

	return {
		c() {
			i = createElement("i");
			addListener(i, "click", click_handler);
			setAttributes(i, i_data);
		},

		m(target, anchor) {
			insert(target, i, anchor);

			if (slot_content_default) {
				append(i, slot_content_default);
			}

			component.refs.icon = i;
		},

		p(changed, ctx) {
			setAttributes(i, getSpreadUpdate(i_levels, [
				(changed.attrs) && ctx.attrs
			]));
		},

		d(detach) {
			if (detach) {
				detachNode(i);
			}

			if (slot_content_default) {
				reinsertChildren(i, slot_content_default);
			}

			removeListener(i, "click", click_handler);
			if (component.refs.icon === i) component.refs.icon = null;
		}
	};
}

function Icon(options) {
	init(this, options);
	this.refs = {};
	this._state = assign({}, options.data);
	this._recompute({  }, this._state);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(Icon.prototype, proto);
assign(Icon.prototype, methods);

Icon.prototype._recompute = function _recompute(changed, state) {
	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
};

/* src/Tab.html generated by Svelte v2.9.11 */

function data() {
    return {
        icon: null,
        iconOnly: false
    }
}
function create_main_fragment$1(component, ctx) {
	var a, text, span, a_class_value, a_href_value;

	var if_block = (ctx.icon) && create_if_block(component, ctx);

	return {
		c() {
			a = createElement("a");
			if (if_block) if_block.c();
			text = createText("\n    ");
			span = createElement("span");
			span.className = "mdc-tab__indicator";
			a.className = a_class_value = "mdc-tab " + ((ctx.icon && !ctx.iconOnly) ?'mdc-tab--with-icon-and-text': '');
			a.href = a_href_value = "#" + ctx.href;
		},

		m(target, anchor) {
			insert(target, a, anchor);
			if (if_block) if_block.m(a, null);
			append(a, text);
			append(a, span);
			component.refs.tab = a;
		},

		p(changed, ctx) {
			if (ctx.icon) {
				if (if_block) {
					if_block.p(changed, ctx);
				} else {
					if_block = create_if_block(component, ctx);
					if_block.c();
					if_block.m(a, text);
				}
			} else if (if_block) {
				if_block.d(1);
				if_block = null;
			}

			if ((changed.icon || changed.iconOnly) && a_class_value !== (a_class_value = "mdc-tab " + ((ctx.icon && !ctx.iconOnly) ?'mdc-tab--with-icon-and-text': ''))) {
				a.className = a_class_value;
			}

			if ((changed.href) && a_href_value !== (a_href_value = "#" + ctx.href)) {
				a.href = a_href_value;
			}
		},

		d(detach) {
			if (detach) {
				detachNode(a);
			}

			if (if_block) if_block.d();
			if (component.refs.tab === a) component.refs.tab = null;
		}
	};
}

// (4:8) {#if !iconOnly}
function create_if_block_1(component, ctx) {
	var span, slot_content_default = component._slotted.default;

	return {
		c() {
			span = createElement("span");
			span.className = "mdc-tab__icon-text";
		},

		m(target, anchor) {
			insert(target, span, anchor);

			if (slot_content_default) {
				append(span, slot_content_default);
			}
		},

		d(detach) {
			if (detach) {
				detachNode(span);
			}

			if (slot_content_default) {
				reinsertChildren(span, slot_content_default);
			}
		}
	};
}

// (2:4) {#if icon}
function create_if_block(component, ctx) {
	var text, text_1, text_2, text_3, text_4, slot_content_default = component._slotted.default, slot_content_default_before, slot_content_default_after;

	var icon_initial_data = { class: "mdc-tab__icon" };
	var icon = new Icon({
		root: component.root,
		store: component.store,
		slots: { default: createFragment() },
		data: icon_initial_data
	});

	var if_block = (!ctx.iconOnly) && create_if_block_1(component, ctx);

	return {
		c() {
			text = createText(ctx.icon);
			icon._fragment.c();
			text_1 = createText("\n        ");
			if (if_block) if_block.c();
			text_2 = createText("\n    ");
			text_3 = createText(ctx.else);
			text_4 = createText("\n        ");
		},

		m(target, anchor) {
			append(icon._slotted.default, text);
			icon._mount(target, anchor);
			insert(target, text_1, anchor);
			if (if_block) if_block.m(target, anchor);
			insert(target, text_2, anchor);
			insert(target, text_3, anchor);
			insert(target, text_4, anchor);

			if (slot_content_default) {
				insert(target, slot_content_default_before || (slot_content_default_before = createComment()), anchor);
				insert(target, slot_content_default, anchor);
				insert(target, slot_content_default_after || (slot_content_default_after = createComment()), anchor);
			}
		},

		p(changed, ctx) {
			if (changed.icon) {
				setData(text, ctx.icon);
			}

			if (!ctx.iconOnly) {
				if (!if_block) {
					if_block = create_if_block_1(component, ctx);
					if_block.c();
					if_block.m(text_2.parentNode, text_2);
				}
			} else if (if_block) {
				if_block.d(1);
				if_block = null;
			}

			if (changed.else) {
				setData(text_3, ctx.else);
			}
		},

		d(detach) {
			icon.destroy(detach);
			if (detach) {
				detachNode(text_1);
			}

			if (if_block) if_block.d(detach);
			if (detach) {
				detachNode(text_2);
				detachNode(text_3);
				detachNode(text_4);
			}

			if (slot_content_default) {
				reinsertBetween(slot_content_default_before, slot_content_default_after, slot_content_default);
				detachNode(slot_content_default_before);
				detachNode(slot_content_default_after);
			}
		}
	};
}

function Tab(options) {
	init(this, options);
	this.refs = {};
	this._state = assign(data(), options.data);
	this._intro = true;

	this._slotted = options.slots || {};

	if (!options.root) {
		this._oncreate = [];
		this._beforecreate = [];
		this._aftercreate = [];
	}

	this.slots = {};

	this._fragment = create_main_fragment$1(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);

		this._lock = true;
		callAll(this._beforecreate);
		callAll(this._oncreate);
		callAll(this._aftercreate);
		this._lock = false;
	}
}

assign(Tab.prototype, proto);

export default Tab;
