(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.ToolbarSection = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/ToolbarSection.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({}, attributes);
        let cls ="mdc-toolbar__section";
        let classes = [cls];
        for (let key of ["align", "shrink-to-fit"]) {
            if (result[key]) {
                if (key === "align") {
                    let v = result[key];
                    if (v === "start" || v === "end") {
                        key += "-"+v;
                    } else {
                        continue;
                    }
                }
                classes.push(cls+"--"+key);
            }
            delete result[key];
        }
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function create_main_fragment(component, ctx) {
    	var section, slot_content_default = component._slotted.default;

    	var section_levels = [
    		ctx.attrs
    	];

    	var section_data = {};
    	for (var i = 0; i < section_levels.length; i += 1) {
    		section_data = shared_js.assign(section_data, section_levels[i]);
    	}

    	return {
    		c() {
    			section = shared_js.createElement("section");
    			shared_js.setAttributes(section, section_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, section, anchor);

    			if (slot_content_default) {
    				shared_js.append(section, slot_content_default);
    			}
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(section, shared_js.getSpreadUpdate(section_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(section);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(section, slot_content_default);
    			}
    		}
    	};
    }

    function ToolbarSection(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(ToolbarSection.prototype, shared_js.proto);

    ToolbarSection.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return ToolbarSection;

})));
