import { append, assign, createElement, detachNode, init, insert, noop, proto, reinsertChildren } from './shared.mjs';

/* src/ToolbarTitle.html generated by Svelte v2.9.11 */

function create_main_fragment(component, ctx) {
	var span, slot_content_default = component._slotted.default;

	return {
		c() {
			span = createElement("span");
			span.className = "mdc-toolbar__title";
		},

		m(target, anchor) {
			insert(target, span, anchor);

			if (slot_content_default) {
				append(span, slot_content_default);
			}
		},

		p: noop,

		d(detach) {
			if (detach) {
				detachNode(span);
			}

			if (slot_content_default) {
				reinsertChildren(span, slot_content_default);
			}
		}
	};
}

function ToolbarTitle(options) {
	init(this, options);
	this._state = assign({}, options.data);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(ToolbarTitle.prototype, proto);

export default ToolbarTitle;
