(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.TopAppBarIcon = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/Icon.html generated by Svelte v2.9.11 */

    function attrs(attributes) {
        let result = Object.assign({"aria_hidden": "true"}, attributes);
        let classes = ["material-icons"];
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    var methods = {
    	getElement() {
    		return this.refs.icon;
    	}
    };

    function create_main_fragment(component, ctx) {
    	var i, slot_content_default = component._slotted.default;

    	function click_handler(event) {
    		component.fire("click", event);
    	}

    	var i_levels = [
    		ctx.attrs
    	];

    	var i_data = {};
    	for (var i_1 = 0; i_1 < i_levels.length; i_1 += 1) {
    		i_data = shared_js.assign(i_data, i_levels[i_1]);
    	}

    	return {
    		c() {
    			i = shared_js.createElement("i");
    			shared_js.addListener(i, "click", click_handler);
    			shared_js.setAttributes(i, i_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, i, anchor);

    			if (slot_content_default) {
    				shared_js.append(i, slot_content_default);
    			}

    			component.refs.icon = i;
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(i, shared_js.getSpreadUpdate(i_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(i);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(i, slot_content_default);
    			}

    			shared_js.removeListener(i, "click", click_handler);
    			if (component.refs.icon === i) component.refs.icon = null;
    		}
    	};
    }

    function Icon(options) {
    	shared_js.init(this, options);
    	this.refs = {};
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(Icon.prototype, shared_js.proto);
    shared_js.assign(Icon.prototype, methods);

    Icon.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    /* src/TopAppBarIcon.html generated by Svelte v2.9.11 */

    function attrs$1(attributes) {
        let result = Object.assign({}, attributes);
        let cls = "mdc-top-app-bar__";
        var classes = [];
        for (let key of ["navigation-icon", "action-item"]) {
            if (result[key] && classes.length === 0) {
                classes.push(cls+key);
            }
            delete result[key];
        }
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function create_main_fragment$1(component, ctx) {
    	var slot_content_default = component._slotted.default;

    	var icon_spread_levels = [
    		ctx.attrs
    	];

    	var icon_initial_data = {};
    	for (var i = 0; i < icon_spread_levels.length; i += 1) {
    		icon_initial_data = shared_js.assign(icon_initial_data, icon_spread_levels[i]);
    	}
    	var icon = new Icon({
    		root: component.root,
    		store: component.store,
    		slots: { default: shared_js.createFragment() },
    		data: icon_initial_data
    	});

    	icon.on("click", function(event) {
    		component.fire("click", event);
    	});

    	return {
    		c() {
    			icon._fragment.c();
    		},

    		m(target, anchor) {
    			if (slot_content_default) {
    				shared_js.append(icon._slotted.default, slot_content_default);
    			}

    			icon._mount(target, anchor);
    		},

    		p(changed, ctx) {
    			var icon_changes = changed.attrs ? shared_js.getSpreadUpdate(icon_spread_levels, [
    				ctx.attrs
    			]) : {};
    			icon._set(icon_changes);
    		},

    		d(detach) {
    			if (slot_content_default) {
    				shared_js.reinsertChildren(icon._slotted.default, slot_content_default);
    			}

    			icon.destroy(detach);
    		}
    	};
    }

    function TopAppBarIcon(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	if (!options.root) {
    		this._oncreate = [];
    		this._beforecreate = [];
    		this._aftercreate = [];
    	}

    	this.slots = {};

    	this._fragment = create_main_fragment$1(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);

    		this._lock = true;
    		shared_js.callAll(this._beforecreate);
    		shared_js.callAll(this._oncreate);
    		shared_js.callAll(this._aftercreate);
    		this._lock = false;
    	}
    }

    shared_js.assign(TopAppBarIcon.prototype, shared_js.proto);

    TopAppBarIcon.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs$1(state)))) changed.attrs = true;
    };

    return TopAppBarIcon;

})));
