import { append, assign, createElement, detachNode, init, insert, noop, proto, reinsertChildren } from './shared.mjs';

/* src/TopAppBarRow.html generated by Svelte v2.9.11 */

function create_main_fragment(component, ctx) {
	var div, slot_content_default = component._slotted.default;

	return {
		c() {
			div = createElement("div");
			div.className = "mdc-top-app-bar__row";
		},

		m(target, anchor) {
			insert(target, div, anchor);

			if (slot_content_default) {
				append(div, slot_content_default);
			}
		},

		p: noop,

		d(detach) {
			if (detach) {
				detachNode(div);
			}

			if (slot_content_default) {
				reinsertChildren(div, slot_content_default);
			}
		}
	};
}

function TopAppBarRow(options) {
	init(this, options);
	this._state = assign({}, options.data);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(TopAppBarRow.prototype, proto);

export default TopAppBarRow;
