import { append, assign, createElement, detachNode, getSpreadUpdate, init, insert, proto, reinsertChildren, setAttributes } from './shared.mjs';

const regex = /%s/gi;

function processClasses(classes, userClasses) {
    if (!userClasses) {
        return classes.join(" ");
    }
    if (Array.isArray(userClasses)) {
        userClasses = userClasses.join(" ");
    }
    if (!regex.test(userClasses)) {
        return userClasses+" "+classes.join(" ");
    }
    return userClasses.replace(regex, classes.join(" "));
}

/* src/TopAppBarSection.html generated by Svelte v2.9.11 */

function attrs(attributes) {
    let result = Object.assign({}, attributes);
    let cls ="mdc-top-app-bar__section";
    let classes = [cls];
    let k = "align";
    let v;
    if (v = result[k]) {
        if (v === "start" || v === "end") {
            classes.push(cls+"--"+k+"-"+v);
        }
        delete result[k];
    }
    delete result.attrs;
    result["class"] = processClasses(classes, result["class"]);
    return result;
}
function create_main_fragment(component, ctx) {
	var section, slot_content_default = component._slotted.default;

	var section_levels = [
		ctx.attrs
	];

	var section_data = {};
	for (var i = 0; i < section_levels.length; i += 1) {
		section_data = assign(section_data, section_levels[i]);
	}

	return {
		c() {
			section = createElement("section");
			setAttributes(section, section_data);
		},

		m(target, anchor) {
			insert(target, section, anchor);

			if (slot_content_default) {
				append(section, slot_content_default);
			}
		},

		p(changed, ctx) {
			setAttributes(section, getSpreadUpdate(section_levels, [
				(changed.attrs) && ctx.attrs
			]));
		},

		d(detach) {
			if (detach) {
				detachNode(section);
			}

			if (slot_content_default) {
				reinsertChildren(section, slot_content_default);
			}
		}
	};
}

function TopAppBarSection(options) {
	init(this, options);
	this._state = assign({}, options.data);
	this._recompute({  }, this._state);
	this._intro = true;

	this._slotted = options.slots || {};

	this.slots = {};

	this._fragment = create_main_fragment(this, this._state);

	if (options.target) {
		this._fragment.c();
		this._mount(options.target, options.anchor);
	}
}

assign(TopAppBarSection.prototype, proto);

TopAppBarSection.prototype._recompute = function _recompute(changed, state) {
	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
};

export default TopAppBarSection;
