(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('./shared.js')) :
    typeof define === 'function' && define.amd ? define(['./shared.js'], factory) :
    (global.Typography = factory(global.svelteShared));
}(this, (function (shared_js) { 'use strict';

    const regex = /%s/gi;

    function processClasses(classes, userClasses) {
        if (!userClasses) {
            return classes.join(" ");
        }
        if (Array.isArray(userClasses)) {
            userClasses = userClasses.join(" ");
        }
        if (!regex.test(userClasses)) {
            return userClasses+" "+classes.join(" ");
        }
        return userClasses.replace(regex, classes.join(" "));
    }

    /* src/Typography.html generated by Svelte v2.9.11 */

    var validTypes = ["caption", "button", "overline"];
    for (let i=1; i < 7; ++i) {
        if (i < 3) {
            validTypes.push("body"+i);
            validTypes.push("subtitle"+i);
        }
        validTypes.push("headline"+i);
    }
    function attrs(attributes) {
        let result = Object.assign({}, attributes);
        let classes = ["mdc-mdc-typography"+(result.type?"--"+result.type : "")];
        if (result.type && !validTypes.includes(result.type)) {
            throw new Error(`Invalid type '${result.type}'}`);
        }
        delete result.type;
        delete result.attrs;
        result["class"] = processClasses(classes, result["class"]);
        return result;
    }
    function create_main_fragment(component, ctx) {
    	var span, slot_content_default = component._slotted.default;

    	var span_levels = [
    		ctx.attrs
    	];

    	var span_data = {};
    	for (var i_1 = 0; i_1 < span_levels.length; i_1 += 1) {
    		span_data = shared_js.assign(span_data, span_levels[i_1]);
    	}

    	return {
    		c() {
    			span = shared_js.createElement("span");
    			shared_js.setAttributes(span, span_data);
    		},

    		m(target, anchor) {
    			shared_js.insert(target, span, anchor);

    			if (slot_content_default) {
    				shared_js.append(span, slot_content_default);
    			}
    		},

    		p(changed, ctx) {
    			shared_js.setAttributes(span, shared_js.getSpreadUpdate(span_levels, [
    				(changed.attrs) && ctx.attrs
    			]));
    		},

    		d(detach) {
    			if (detach) {
    				shared_js.detachNode(span);
    			}

    			if (slot_content_default) {
    				shared_js.reinsertChildren(span, slot_content_default);
    			}
    		}
    	};
    }

    function Typography(options) {
    	shared_js.init(this, options);
    	this._state = shared_js.assign({}, options.data);
    	this._recompute({  }, this._state);
    	this._intro = true;

    	this._slotted = options.slots || {};

    	this.slots = {};

    	this._fragment = create_main_fragment(this, this._state);

    	if (options.target) {
    		this._fragment.c();
    		this._mount(options.target, options.anchor);
    	}
    }

    shared_js.assign(Typography.prototype, shared_js.proto);

    Typography.prototype._recompute = function _recompute(changed, state) {
    	if (this._differs(state.attrs, (state.attrs = attrs(state)))) changed.attrs = true;
    };

    return Typography;

})));
